# lighttpd configuration file
#
# use it as a base for lighttpd 1.0.0 and above
#
# $Id: lighttpd.conf 8860 2008-08-05 10:56:16Z engy $

############ Options you really have to take care of ####################

## modules to load
# at least mod_access and mod_accesslog should be loaded
# all other module should only be loaded if really neccesary
# - saves some time
# - saves memory
server.modules = (
                               "mod_alias",
                               "mod_access",
                               "mod_accesslog",
#                              "mod_cml",
#                              "mod_trigger_b4_dl",
                               "mod_auth",
#                              "mod_status",
#                              "mod_setenv",
#                              "mod_fastcgi",
#                              "mod_proxy",
#                              "mod_simple_vhost",
                               "mod_rewrite",
                               "mod_redirect",
#                              "mod_evhost",
#                              "mod_userdir",
                               "mod_cgi",
#                              "mod_compress",
#                              "mod_ssi",
#                              "mod_usertrack",
#                              "mod_expire",
#                              "mod_secdownload",
#                              "mod_rrdtool",
                               "mod_webdav"
    )

debug.log-request-handling = "enable"
debug.log-state-handling = "enable"
## a static document-root, for virtual-hosting take look at the
## server.virtual-* options
server.document-root        = "/tmp"

## where to send error-messages to
#server.errorlog             = "/tmp/webdav/error.log"

# files to check for if .../ is requested
index-file.names            = ( "index.php", "index.html",
                                "index.htm", "default.htm",
    "lighttpd/index.html" )

## set the event-handler (read the performance section in the manual)
server.event-handler = "poll" # needed on OS X

server.max-write-idle = 300
server.upload-dirs = ("/tmp")
server.max-request-size = 10000000

# mimetype mapping
mimetype.assign             = (
  ".pdf"          =>      "application/pdf",
  ".sig"          =>      "application/pgp-signature",
  ".spl"          =>      "application/futuresplash",
  ".class"        =>      "application/octet-stream",
  ".ps"           =>      "application/postscript",
  ".torrent"      =>      "application/x-bittorrent",
  ".dvi"          =>      "application/x-dvi",
  ".gz"           =>      "application/x-gzip",
  ".pac"          =>      "application/x-ns-proxy-autoconfig",
  ".swf"          =>      "application/x-shockwave-flash",
  ".tar.gz"       =>      "application/x-tgz",
  ".tgz"          =>      "application/x-tgz",
  ".tar"          =>      "application/x-tar",
  ".zip"          =>      "application/zip",
  ".mp3"          =>      "audio/mpeg",
  ".m3u"          =>      "audio/x-mpegurl",
  ".wma"          =>      "audio/x-ms-wma",
  ".wax"          =>      "audio/x-ms-wax",
  ".ogg"          =>      "application/ogg",
  ".wav"          =>      "audio/x-wav",
  ".gif"          =>      "image/gif",
  ".jpg"          =>      "image/jpeg",
  ".jpeg"         =>      "image/jpeg",
  ".png"          =>      "image/png",
  ".xbm"          =>      "image/x-xbitmap",
  ".xpm"          =>      "image/x-xpixmap",
  ".xwd"          =>      "image/x-xwindowdump",
  ".css"          =>      "text/css",
  ".html"         =>      "text/html",
  ".htm"          =>      "text/html",
  ".js"           =>      "text/javascript",
  ".asc"          =>      "text/plain",
  ".c"            =>      "text/plain",
  ".cpp"          =>      "text/plain",
  ".log"          =>      "text/plain",
  ".conf"         =>      "text/plain",
  ".text"         =>      "text/plain",
  ".txt"          =>      "text/plain",
  ".dtd"          =>      "text/xml",
  ".xml"          =>      "text/xml",
  ".mpeg"         =>      "video/mpeg",
  ".mpg"          =>      "video/mpeg",
  ".mov"          =>      "video/quicktime",
  ".qt"           =>      "video/quicktime",
  ".avi"          =>      "video/x-msvideo",
  ".asf"          =>      "video/x-ms-asf",
  ".asx"          =>      "video/x-ms-asf",
  ".wmv"          =>      "video/x-ms-wmv",
  ".bz2"          =>      "application/x-bzip",
  ".tbz"          =>      "application/x-bzip-compressed-tar",
  ".tar.bz2"      =>      "application/x-bzip-compressed-tar"
 )

# Use the "Content-Type" extended attribute to obtain mime type if possible
#mimetype.use-xattr        = "enable"

## send a different Server: header
## be nice and keep it at lighttpd
# server.tag                 = "lighttpd"

#### accesslog module
#accesslog.filename          = "/tmp/webdav/access.log"

## deny access the file-extensions
#
# ~    is for backupfiles from vi, emacs, joe, ...
# .inc is often used for code includes which should in general not be part
#      of the document-root
url.access-deny             = ( "~", ".inc" )

#$HTTP["url"] =~ "\.pdf$" {
#  server.range-requests = "disable"
#}

static-file.exclude-extensions = ( ".cgi", ".fcgi", ".php", ".pl", ".py", ".rb" )

server.port = 8080
#$SERVER["socket"] == "0.0.0.0:8080"{}

## bind to localhost (default: all interfaces)
#server.bind                = "grisu.home.kneschke.de"

## error-handler for status 404
#server.error-handler-404   = "/error-handler.html"
#server.error-handler-404   = "/error-handler.php"

## to help the rc.scripts
server.pid-file            = "/var/run/lighttpd.pid"

cgi.assign = (".cgi" => "")

#### auth module
## read authentication.txt for more info
#auth.backend               = "htpasswd"
#auth.backend.plain.userfile = "/var/www/passwd.dav"
#auth.backend.plain.groupfile = "lighttpd.group"

#server.modules += ( "mod_fastcgi" )

server.follow-symlink = "disable"

#fastcgi.server = ( ".php" =>
# (( "socket" => "/tmp/php-fastcgi.socket",
# "bin-path" => "/usr/bin/php-fcgi"
#))
#)

#fastcgi.server = ( ".php" =>
#   ( "localhost" =>
#    ( "socket" => "/tmp/php-fcgi.sock",
#     "bin-path" => "/usr/bin/php-cgi",
#     "max-procs" => 1,
#     "bin-environment" =>
#     ( "PHP_FCGI_CHILDREN" => "2",
#     "PHP_FCGI_MAX_REQUESTS" => "1000" )
#    )
#   )
#)

#alias.url = ("/nas" => "/tmp/nas")
$HTTP["url"] =~ "^/nas" {
 webdav.activate = "enable"
 webdav.is-readonly = "disable"
 dir-listing.activate = "enable"

# auth.backend = "plain"
  auth.backend = "htdigest"
# 		auth.backend.plain.userfile = "/tmp/passwd.dat"
		auth.backend.htdigest.userfile = "/tmp/passwd.dat"
        auth.require = ( "" => (
#				"method" => "basic",
				"method" => "digest",
				"realm" => "webdav",
				"require" => "valid-user" ))
}

